import java.util.*;


class Golomb implements Problem{
	int n;
	int[] lineal;
	
	Golomb(int n) {
		lineal = new int[n];
		this.n = n;
		for(int i=0; i < n; i++) lineal[i] = -1;
		lineal[0] = 0;
	}
	
	HashSet<Integer> diffs = new HashSet<>();
	public boolean feasible(){
		if(lineal[n-1] == -1) return false;
		diffs.clear();
		for(int i=0; i < n; i++){
			for(int j = i+1; j < n ; j++){
				int diff = lineal[j] -lineal[i];
				if(diffs.contains(diff))
					return false;
				else
					diffs.add(diff);
			}
		}
		return true;
	}
	
	List<Problem> res = new LinkedList<>();
	public List<Problem> successors(){
			res.clear();
			int idx =0; 
			while(idx < n && lineal[idx] != -1) idx++;
			if(idx == n) return res;
			for(int i = lineal[idx-1]+1 ; i < n*n; i++){ // Wertauswahl absteigend
			//for(int i = n*n  ; i > lineal[idx-1]; i--){	// Wertauswahl aufsteigend
				Golomb next = this.clone();
				next.lineal[idx] = i;
				res.add(next);
			}
			//System.out.println("succ: "+res);
			return res;
	}
	
	public Golomb clone(){
		Golomb res = new Golomb(n);
		res.lineal = new int[n];
		for(int i=0; i < n; i++) res.lineal[i] = this.lineal[i];
		return res;
	}
	public int getQuality(){
		return lineal[n-1];
	}
	public int getCurrentQuality(){
		int idx =0;
		while(idx < n && lineal[idx] != -1) idx++;
		return lineal[idx-1];
	}
	
	public int compareTo(Problem other){
		if(this.getCurrentQuality() < other.getCurrentQuality()) return -1;
		// liefert nie 0 (Gleichheit) bzgl currentQuality, damit die Elemente 
		//im TreeSet (Set!) nicht verloren gehen	
		return 1;
	}
	
	public String toString(){
		return Arrays.toString(lineal);	
	}

}