import java.util.*;


class TSP implements Problem{
	List<String> orte;
	int path;
	Map map;
	
	TSP(Map m) {
		path =0;
		orte = new LinkedList<String>();
		orte.add(m.getStart());
		map = m;
	}
	
	
	public boolean feasible(){
		if(orte.size() != map.getNumOrte() + 1) // nich alle Orte dabei
			return false;
		if(! orte.get(0).equals(orte.get(orte.size()-1)))// keine Rundreise
			return false;
		return true;
	}
	
	List<Problem> res = new LinkedList<>();
	public List<Problem> successors(){
			res.clear();
			String last = orte.get(orte.size() -1);
			for(String next : map.getNeighbors(last)){
				if(!orte.contains(next) || // war noch nicht da
				   (orte.size() == map.getNumOrte() &&next.equals(orte.get(0))) // oder der weg nach hause
				){
					TSP n = this.clone();
					n.orte.add(next);
					n.path += map.getDist(last,next);
					res.add(n);
				}
			}
			return res;
	}
	
	public TSP clone(){
		TSP res = new TSP(this.map);
		res.path = this.path;
		res.orte = new LinkedList<String>();
		for(String x : this.orte) res.orte.add(new String(x));
		return res;
	}
	public int getQuality(){return path;}
	
	public int getCurrentQuality(){return getQuality();}
	
	public int compareTo(Golomb other){
		if(this.getCurrentQuality() < other.getCurrentQuality()) return -1;
		if(this.getCurrentQuality() == other.getCurrentQuality()) return 0;	
		return 1;
	}
	
	public String toString(){
		return orte.toString()+","+path;	
	}

}